SystemOrganization addCategory: #'Xen-Tests'!

Object subclass: #ButtonTest1
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xen-Tests'!

!ButtonTest1 commentStamp: 'NolanVoid 5/1/2014 18:50' prior: 0!
A ButtonTest is a test that creates a button and opens a Transcript. When the button is clicked, a message appears in the Transacript.
!

!ButtonTest1 methodsFor: 'initialization' stamp: 'NolanVoid 5/5/2014 00:16'!
initialize
	"Open a Transcript and create a button."

	Transcript openLabel: 'Xen-Tests'.
	XTButton new.
! !

Object subclass: #ButtonTest2
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xen-Tests'!

!ButtonTest2 commentStamp: 'NolanVoid 5/1/2014 18:50' prior: 0!
A ButtonTest is a test that creates a button and opens a Transcript. When the button is clicked, a message appears in the Transacript.
!

!ButtonTest2 methodsFor: 'initialization' stamp: 'NolanVoid 5/4/2014 01:35'!
initialize
	"Open a Transcript and create a button."

	Transcript openLabel: 'Xen-Tests: targeted'.
	XTTargetButton new.
! !

Object subclass: #ObHacker
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xen-Tests'!

!ObHacker commentStamp: 'NolanVoid 5/30/2014 14:52' prior: 0!
An ObHacker is used to test overriding of Object features.
!

!ObHacker methodsFor: 'as yet unclassified' stamp: 'NolanVoid 5/30/2014 15:44'!
printOn: aStream
	"Change the way this class is printed"

	| name |
	name := 'tester'.
	name = #unnamed
		ifFalse: [ 
			^ aStream
				nextPutAll: 'Hacking ';
				nextPutAll: name ].
	self storeOn: aStream! !

Object subclass: #XenColTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xen-Tests'!

!XenColTest commentStamp: 'NolanVoid 6/26/2014 02:24' prior: 0!
A XenColTest is used for testing Collection ideas. Basically, this relieves us of the need to create lots of globals.
!

!XenColTest class methodsFor: 'as yet unclassified' stamp: 'NolanVoid 7/3/2014 14:55'!
collOps
	"Tests of collection operators."

	| col  res |
	col := #('apple' 'bat' 'cassowary' 'delta' 'eponymous' 'far').
	res := col doWithIndex: [ :el :i | (el includes: $w) ifTrue: [^ i] ].
	
	col select: [ :el | el includesSubstring: 'a' ].
	res := col select: [ :el | el includes: $a ].
	res := col select: [ :el | el includesSubstring: 'ar' ].
	res := col select: [ :el | el endsWith: 'ry' ].
	res := col select: [ :el | el beginsWith: 'epo' ].
	res := col select: [ :el | el beginsWithEmpty: 'epo'  caseSensitive: true ].
	res := col select: [ :el | el includesAll: #($a $o) ].
	res := col select: [ :el | '*ar*'  match: el ].
	res := col collect: [ :el | el at: 1 ].
	res := col collect: [ :el | el truncateTo: 2 ].
	res := col collect: [ :el | el allButFirst ].
	res := col collect: [ :el | el allButLast  ].
	res := col collect: [ :el | el allButLast: 2  ].
	res := col collect: [ :el | (el allButFirst: 1) allButLast: 1 ].
	res := col collect: [ :el | el at: 2 put: $x. el.  ]. "This destructively changes col".
	res := col collect: [ :el | el asUppercase ].
	col := #('apple' 'bat' 'cassowary' 'delta' 'eponymous' 'far').
	res := col collect: [ :el | (el copy) at: 2 put: $x. el.  ]. "This doesn't".
	res := col collect: [ :el | el asUppercase ].
	res := col reject: [ :el | el includesSubstring: 'ar' ].
	res := col detect: [ :el | el includesSubstring: 'ar' ].
	res := col inject: '' into: [ :merge :el | merge, (el first: 1) ].
	! !

!XenColTest class methodsFor: 'as yet unclassified' stamp: 'NolanVoid 7/3/2014 15:54'!
doDict
	"Tests of collection operators."

	| colors |
	colors := Dictionary newFrom: { #yellow  -> Color yellow. #blue -> Color blue. #red ->Color red }.
	colors keysDo: [:key | Transcript show: key; cr]. 
	colors valuesDo: [:value | Transcript show: value;cr]. 
	colors associationsDo: [:value | Transcript show: value;cr]. 

	
	! !

!XenColTest class methodsFor: 'as yet unclassified' stamp: 'NolanVoid 7/3/2014 15:50'!
doOps
	"Tests of collection operators."

	| col  res |
	col := #('apple' 'bat' 'cassowary' 'delta' 'eponymous' 'far').	
	String streamContents: [:stream | col asStringOn: stream delimiter: '.' ]. 
	
	col := #('apple' 'bat' 'cassowary' 'delta' 'eponymous' 'far').
	res := ''.
	col reverseDo: [ :el | res := res, (el first: 1) ] .
	res.
	
	col := #('apple' 'bat' 'cassowary' 'delta' 'eponymous' 'far').
	res := ''.
	col do: [ :el | res := res, el ] separatedBy: [ res := res, '.' ].
	
	res := col doWithIndex: [ :el :i | (el includes: $w) ifTrue: [^ i] ].
	
	! !

!XenColTest class methodsFor: 'as yet unclassified' stamp: 'NolanVoid 6/26/2014 03:17'!
lotteries
	"Blue Book lotteries on page 134."

	| lotteryA lotteryB |
	lotteryA := Bag newFrom: #(272  572  852  156).
	lotteryB := Bag newFrom: #(572 621  274).
	lotteryA isEmpty.
	lotteryA includes: 572.
	lotteryA add: 596.
	lotteryA addAll: lotteryB.
	lotteryA remove: 572.
	lotteryA size.
	lotteryA removeAll: lotteryB.
	lotteryA size.
! !

Object subclass: #XenFSTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xen-Tests'!

!XenFSTests commentStamp: 'NolanVoid 7/10/2014 00:53' prior: 0!
I contain tests of the new FileSystem packages (within my class methods).
!

!XenFSTests class methodsFor: 'as yet unclassified' stamp: 'NolanVoid 7/13/2014 05:23'!
basicTests
	"Basic tests of the FileSystem packages."

	| fs fr |
	fr := 'h:\DirA\DirB1\FooB1.txt' asFileReference.
	fr entry creationSeconds. 

	fr := 'h:\DirA' asFileReference.
	fr / 'DirB1' moveTo: fr / '..' / 'DirZ'. 

	fr := 'h:\DirA\DirB1\' asFileReference.
	fr / 'FooB1.txt' moveTo: fr / '..' / 'Sprok.txt'.

	fr := 'h:\DirA\FooA.txt' asFileReference.
	fr renameTo: 'Spoo.txt'.
	
	fr := 'h:\DirA\FooA.txt' asFileReference.
	fr renameTo: fr / '..' / 'Spoo.txt'.

	fr := 'h:\DirA' asFileReference.
	fr copyAllTo: fr / '..' / 'DirC'.

	fs := FileSystem disk.
	fs copy: 'h:\DirA\FooA.txt' asPath to: 'h:\DirA\Spoo.txt' asPath.
	
	fr := 'h:\DirA\FooA.txt' asFileReference.
	fr copyTo: fr / '..' / 'Spoo.txt'.

	fs := FileSystem disk.
	fs workingDirectoryPath: (Path / 'h:' / 'DirA').
	'FooA.txt' asFileReference copyTo: 'Spoo.txt' asFileReference.
	fs workingDirectoryPath: (FileLocator vmDirectory absolutePath).
	fs workingDirectoryPath.
	
	(Path / 'DirA') containsPath: (Path / 'DirA' / 'DirB').
	(Path / 'DirA') containsPath: (Path / 'DirA' / 'DirB' / 'DirC' ).
	(Path / 'DirA' / 'DirB') containsPath: (Path / 'DirA' / 'DirB' / 'DirC' ).
	(Path / 'DirA' / 'DirB') containsPath: (Path / 'DirA').
	
	fr := 'h:\DirA\' asFileReference.
	fr := 'h:\DirA\FooA.txt' asFileReference.
	fr glob: [:ref | ^ ref basename].

	fr := 'h:\DirA\' asFileReference.
	(fr filesMatching: '*.txt')
		collect: #basename. 

	fr := 'h:\DirA\' asFileReference.
	fr allChildren
		select: [:ref | ref isFile and: ref extension = 'txt']
		thenCollect: #basename.

	fr := 'h:\DirA\FooA.txt' asFileReference.
	fr copyTo: ('Baz.txt' asFileReference).
	
	fr := 'c:\Apps\ConEmu\Xen.xml' asFileReference.
	fr humanReadableSize.
! !

Object subclass: #XenNumTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xen-Tests'!

!XenNumTests commentStamp: 'NolanVoid 5/20/2014 10:02' prior: 0!
Number tests.
!

!XenNumTests class methodsFor: 'math' stamp: 'NolanVoid 5/20/2014 10:35'!
bounce
	"Explore bouncing function values"

	| |
	Transcript openLabel: 'Bouncing function values'.
	Transcript clear.
	-1 to: 1 by: 0.1 do:
		[ :each|
			| x y |
			x := each.
			y := x raisedTo: 0.5 * x.
			y := y round: 14.
			Transcript show: y ; cr].! !

!XenNumTests class methodsFor: 'math' stamp: 'NolanVoid 5/20/2014 10:10'!
piCount
	"Count up by pi"

	| negpi pospi |
	negpi := (Float pi) negated.
	pospi := (Float pi).
	Transcript openLabel: 'Xen Number Tests'.
	Transcript clear.
	negpi to: pospi by: pospi/4 do: [ :each| Transcript show: each sin; cr].! !

Object subclass: #XenPackageLister
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xen-Tests'!

!XenPackageLister commentStamp: 'NolanVoid 7/17/2014 00:15' prior: 0!
I provide methods for listing the names of all the loaded packages.
!

!XenPackageLister class methodsFor: 'as yet unclassified' stamp: 'NolanVoid 7/17/2014 00:29'!
listPackageNames
	"Print on the Transcript a sorted list of the names of all loaded packages."

	| packNames listText |
	packNames := ((PackageInfo allPackages) collect: [:packInfo | packInfo packageName]) asSortedCollection.
	listText := String streamContents:
					[ :stream |
						 packNames do: 
							[:aName | 
								stream nextPutAll: (aName withoutQuoting);
								cr.]].
	Transcript show: listText.! !

Object subclass: #XenStreamTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xen-Tests'!

!XenStreamTest commentStamp: 'NolanVoid 7/5/2014 02:22' prior: 0!
A XenStreamTest is a scratchpad for tests of Smalltalk's stream classes.
!

!XenStreamTest class methodsFor: 'as yet unclassified' stamp: 'NolanVoid 7/7/2014 01:41'!
basicStream
	"Basic stream operations"

	| r w rw |

	r := 'abcdef' readStream.
	r contents.
	r next.
	
	r := 'Twas brillig and the slithey toves' substrings readStream.
	r skipTo: 'the'.
	r next.
	
	r := 'abcdef' readStream.
	r position: 2.
	r next.
	
	w := 'abcdef' writeStream.
	w contents.
		
	r := ReadStream on: 'abcdef'.
	r upToEnd.
	r reset.
	r peekFor: $a.
	r next: 3.
	r peek.
	r next.
	r next.
	r peekBack.
	r setToEnd.
		
	r := ReadStream on: (1 to: 100).
	r next: 3.
	r atEnd.
	r contents.
	
	rw := ReadWriteStream on: 'abcde'.
	rw reset.
	rw next.
	
	w := WriteStream on: (String new: 5).
	w nextPut: $a.
	w nextPut: $b.
	w nextPut: $c.
	w nextPut: $d.
	w nextPut: $e.
	w nextPut: $f.
	w contents.
	
	StandardFileStream
		fileNamed: 'test.txt'
		do: [:str | str
				nextPutAll: '123';
				cr;
				nextPutAll: 'abcd'].	
! !

!XenStreamTest class methodsFor: 'as yet unclassified' stamp: 'NolanVoid 7/9/2014 23:59'!
fileStreams
	"Test of file streams."
	
	| file stuff |
	
	stuff := StandardFileStream readOnlyFileNamed: 'testB.txt' do:
		[:fileStream | fileStream contents].
	Transcript show: stuff.
	
	StandardFileStream forceNewFileNamed: 'testB.txt' do:
		[ :fileStream |
			fileStream
				nextPutAll: 'The future''s uncertain'; cr;
				nextPutAll: 'and the end is always near.'; cr;
				close.
		].
	
	file := StandardFileStream forceNewFileNamed: 'testB.txt'.
	file
		nextPutAll: 'In a gadda'; cr;
		nextPutAll: 'da vida, baby!!'; cr;
		close.
	
	file := StandardFileStream readOnlyFileNamed: 'test.txt'.
	Transcript show: (file contents).
	file close.
	! !

!XenStreamTest class methodsFor: 'as yet unclassified' stamp: 'NolanVoid 7/8/2014 04:19'!
readWriteStreams
	"Test of ReadWriteStream class."
	
	| stream |
	stream := ReadWriteStream on: 'abcdef'  from: 1 to: 'abcdef' size.
	stream
		 next;
		 nextPut: $x.
		 
	stream	contents.
	
! !

!XenStreamTest class methodsFor: 'as yet unclassified' stamp: 'NolanVoid 7/7/2014 03:31'!
stringStream
	"Consing up a string from data."
	| string |
	string := String streamContents:
	[:stream |
		stream
			print: #(1 2 3);
			space;
			nextPutAll: 'size';
			space;
			nextPut: $=;
			space;
			print: 3.  ].
		
string. 
! !

!XenStreamTest class methodsFor: 'as yet unclassified' stamp: 'NolanVoid 7/7/2014 03:29'!
writeStreams
	"Testing writeStream"
	| stream |
	
	stream := String new writeStream.
	stream
		nextPutAll: 'This Smalltalk image contains: ';
		print: Smalltalk allClasses size;
		nextPutAll: ' classes.';
		cr;
		nextPutAll: 'This is really a lot.'.
		
	stream contents.! !

Object subclass: #XenaSpace
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xen-Tests'!

!XenaSpace commentStamp: 'NolanVoid 5/23/2014 08:10' prior: 0!
A XenaSpace is basically just a namespace for playing around with variables and whatnot.
!

!XenaSpace class methodsFor: 'closures' stamp: 'NolanVoid 5/7/2014 01:16'!
bar
	"Outer function."
	| x y |
	x := 5.
	y := 6.
	^  self foo value

! !

!XenaSpace class methodsFor: 'closures' stamp: 'NolanVoid 5/7/2014 01:14'!
foo
	"Inner function."
	| x y |
	x := 3.
	y := 4.
	^  [x + y]

! !

!XenaSpace class methodsFor: 'closures' stamp: 'NolanVoid 5/7/2014 00:06'!
lexicalClosure
	"Demonstrate a lexical closure as a lambda."

	| x y |
	x := 3.
	y := 4.
	^ [x + y] value! !

!XenaSpace class methodsFor: 'loops' stamp: 'NolanVoid 5/7/2014 06:42'!
loopTest
	"Basic loop test."
	
	| n |
	n := 1.
	[ n <1000 ] whileTrue: [ n := n*2 ].
	^ n! !

!XenaSpace class methodsFor: 'loops' stamp: 'NolanVoid 5/7/2014 06:50'!
loopTest2
	"Basic loop test."
	
	| n |
	n := 1.
	10 timesRepeat: [ n := n*2 ].
	^ n! !

!XenaSpace class methodsFor: 'mapping' stamp: 'NolanVoid 5/7/2014 07:20'!
mapping1
	"Collect mapping"

	^ (1 to: 10) collect: [:n| n*n]! !

!XenaSpace class methodsFor: 'mapping' stamp: 'NolanVoid 5/7/2014 07:23'!
selectMap
	"Select mapping"

	^ 'hello there' select: [ :char | char isVowel ]! !

!XenaSpace class methodsFor: 'closures' stamp: 'NolanVoid 5/4/2014 21:03'!
simpleClosure
	"Return a simple closure."

	| x y |
	x := 3.
	y := 4.
	^ [x + y]! !

!XenaSpace class methodsFor: 'loops' stamp: 'NolanVoid 5/7/2014 07:05'!
tobydoLoop
	"Basic loop test."
	
	| result |
	result := String new.
	1 to: 10 by: 0.3 do: [:n | result := result, n printString, ' '].
	^ result
	! !

!XenaSpace class methodsFor: 'loops' stamp: 'NolanVoid 5/7/2014 07:05'!
todoLoop
	"Basic loop test."
	
	| result |
	result := String new.
	1.3 to: 10 do: [:n | result := result, n printString, ' '].
	^ result
	! !

!XenaSpace class methodsFor: 'closures' stamp: 'NolanVoid 5/7/2014 01:00'!
whatsis
	"Demonstrate a dynamic closure as a lambda."

	| x y foo |
	x := 3.
	y := 4.
	foo :=  [x + y].
	x := 5.
	y := 6.
	^ foo value! !

SimpleButtonMorph subclass: #XTButton
	instanceVariableNames: 'mouseAction'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xen-Tests'!

!XTButton commentStamp: 'NolanVoid 5/1/2014 19:08' prior: 0!
A XTButton is a widget that prints a message in the Transcript.
!

!XTButton methodsFor: 'initialization' stamp: 'NolanVoid 5/5/2014 00:16'!
initialize
	"Set up the button."

	super initialize.
	self
		bottomLeft: 60@200;
		color: (Color r: 0.6 g: 1.0 b: 0.8 alpha: 1.0);
		label: 'Send message';
		helpText: 'Click me to send a message to the Transcript';
		openInWorld
! !

!XTButton methodsFor: 'event handling' stamp: 'NolanVoid 5/5/2014 00:14'!
mouseUp: evt
	"Send a message to the Transcript."

	super mouseUp: evt.
	Transcript show: 'Magical message!!'; cr! !

SimpleButtonMorph subclass: #XTTargetButton
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xen-Tests'!

!XTTargetButton commentStamp: 'NolanVoid 5/4/2014 01:35' prior: 0!
A XTTargetButton is a button that sends its target (a Transcript) a message.
!

!XTTargetButton class methodsFor: 'as yet unclassified' stamp: 'NolanVoid 7/13/2014 23:05'!
buttonTest
	"Test an XTTargetButton."

	| button |
	button := XTTargetButton new.! !

!XTTargetButton methodsFor: 'initialization' stamp: 'NolanVoid 7/13/2014 23:10'!
initialize
	"Set up the button."

	super initialize.
	self
		bottomLeft: 60@200;
		color: (Color r: 0.6 g: 1.0 b: 0.8 alpha: 1.0);
		label: 'Send message';
		helpText: 'Click me to send a message to the Transcript';
		target: Transcript;
		actionSelector: #show:;
		arguments: {'Magic targeted message!!', String cr};
		openInWorld! !
